% "   "
%            No2
% :        
%              
%         

%% 
clear
format short
clc

fprintf('\n######      2    ######\n');
correctInput = false;
while not(correctInput)
    otg=input('#    mees_2_student_edit.m,       ? (->1; ->2) [2]: ');
    if isempty(otg)
        %   tnac
        otg = 2;
        fprintf('\b%2');
    end
    if isreal(otg) && (otg==1)
        correctInput = true;
        fprintf('\n');
    else
        fprintf('\n!!!     mees_2_student_edit.m   ,    !!!\n\n');
    end
end

%%       
mees_2_student_edit

US = 110;  %       US, [kV]
fn = 500;  %      ,   ..  , [Hz]
bt = 20;   % [   ]

%%        
dt=1/(bt*fn); t=0; NZ=0;
%   Tmatr
Tmatr= [1  0  1;
    0  1  1;
    -1 -1  1 ];
Tmatr_Inv=inv(Tmatr);

L1=X1/(pi*100);
%   
DX=dt/(sqrt(L1*C1));  N=ceil(Lw/DX);

%    
G1=0.08*C1;
abc=1-(G1/(2*C1))*dt;
r1=sqrt(L1/C1)*(1+(R1/(2*L1))*dt/abc);
a=(1+(G1/(2*C1))*dt)/abc;
b=sqrt(L1/C1)*(1-(R1/(2*L1))*dt/abc);

%        gr
gr=pi/180;    w=pi*100;
q3=sqrt(3);  q2=sqrt(2);
ALFA=ALFA*gr;

Unf= [  (q2*US/q3)*sin(ALFA);
        (q2*US/q3)*sin(ALFA-120*gr);
        (q2*US/q3)*sin(ALFA+120*gr)];

Uf=zeros((N+1),3);
Uf(1,1:3)= Unf(1:3,1)';
Uk(1:(N+1),1:3)=(Tmatr_Inv*Uf(1:(N+1),1:3)')';
Unk(1:3,1)=Uk(1,1:3)';

Ep=zeros((N+1),3);
Ep(1,1:3)= a*Uk(1,1:3);

Eo=zeros((N+1),3);

Ekkp(1:3,1)=Ep(N,1:3)';

Ekf=Tmatr*Ekkp;

T(1,1)=t;
UN(1,1:3)=Unf';
UK(1,1:3)=zeros(1,3);
IN(1,1:3)=zeros(1,3);

L=1; Lk=ceil(tkr/dt)+1;
fprintf('\n##### ... \n');
fprintf('t = %8.5f s', t);
while (Lk-L),
    t=t+dt;
    L=L+1;
    fprintf('\b\b\b\b\b\b\b\b\b\b\b\b\b\bt = %8.5f s', t);
    Enko(1:3,1)=Eo(2,1:3)';
    Enf=Tmatr*Enko;
    Ekkp(1:3,1)=Ep(N,1:3)';
    Ekf=Tmatr*Ekkp;
    Unf= [  (q2*US/q3)*sin(w*t+ALFA);
            (q2*US/q3)*sin(w*t+ALFA-120*gr);
            (q2*US/q3)*sin(w*t+ALFA+120*gr)];
    
    Ukf=Ekf;
    Inf=(Unf-Enf)/r1;
    Unk=Tmatr_Inv*Unf;
    Ukk=Tmatr_Inv*Ukf;
    ENp=2*Unk-Enko;
    ENo=2*Ukk-Ekkp;
    
    for K=(N-1):-1:1
        Ep(K+1,:)=Ep(K,:)*exp(-R1/(2*L1)*dt);
    end
    
    Ep(1,:)=ENp'*exp(-R1/(2*L1)*dt);
    
    for K=3:(N+1)
        Eo(K-1,:)=Eo(K,:)*exp(-R1/(2*L1)*dt);
    end
    
    Eo(N+1,:)=ENo'*exp(-R1/(2*L1)*dt);
    
    if t>=tnac
        NZ=NZ+1;
        T(NZ,1)=t;
        UN(NZ,1:3)=Unf';
        UK(NZ,1:3)=Ukf';
        IN(NZ,1:3)=Inf';
    end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% 
otg=1;
tnacn=tnac;
tkrn=tkr;

fprintf('\n\n##### ... \n\');

%   
while otg
    otg=input('###    ? (U, U->1; I->2; ->0) [1]: ');
    if isempty(otg)
        otg = 1;
        fprintf('\b1 \n');
    elseif (otg~=1) && (otg~=2)
        %  
        fprintf('\n#####  \n');
        return;
    end
    if otg~=0,
        jjj=input('#       t? (1->; 0->) [0]: ');
        if isempty(jjj)
            jjj = 0;
            fprintf('\b0 \n');
        elseif jjj==1
            fprintf('(      %6.4f  %6.4f !)\n', tnac, tkr);
            correctInput = false;
            while not(correctInput)
                new_tnacn=input(sprintf(' t  s [%6.4f]: ', tnac));
                if isempty(new_tnacn)
                    %   tnac
                    correctInput = true;
                    fprintf('\b%6.4f s\n', tnac);
                elseif isreal(new_tnacn) && (new_tnacn>=tnacn) && (new_tnacn<=tkr)
                    tnacn = new_tnacn;
                    correctInput = true;
                    fprintf('\b s\n');
                else
                    fprintf('\n!!! t       %6.4f  %6.4f !!!\n', tnac, tkr);
                end
            end
            
            correctInput = false;
            while not(correctInput)
                new_tkr=input(sprintf(' t  s [%6.4f]: ', tkr));
                if isempty(new_tkr)
                    %   tkr
                    correctInput = true;
                    fprintf('\b%6.4f s\n', tkrn);
                elseif isreal(new_tkr) && (new_tkr>=tnac) && (new_tkr<=tkr)
                    tkrn = new_tkr;
                    correctInput = true;
                    fprintf('\b s\n');
                else
                    fprintf('\n!!! t       %6.4f  %6.4f !!!\n', tnac, tkr);
                end
            end
        end
    end
    
    BTN=ceil((tnacn-tnac)/dt)+1;
    if BTN<1, BTN=1; end
    BTK=ceil((tkrn-tnac)/dt);
    if BTK>NZ, BTK=NZ; end
    
    %   
    if otg==1
        fprintf('#       %6.4f  %6.4f s...\n\n', tnacn, tkrn);
        h = figure('NumberTitle', 'off', 'Name', '       ');
        ymin=min(min(UN(BTN:BTK,1:3)));
        ymax=max(max(UN(BTN:BTK,1:3)));
        subplot(211), axis([T(BTN,1) T(BTK,1) ymin ymax])
        plot(T(BTN:BTK,1),UN(BTN:BTK,1),':',....
            T(BTN:BTK,1),UN(BTN:BTK,2),'-',....
            T(BTN:BTK,1),UN(BTN:BTK,3),'-.')
        ylabel('U_{nachalo}, [kV]'); xlabel('t, [s]');
        grid on; legend(' U_{A}', ' U_{B}', ' U_{C}');
        
        ymin=min(min(UK(BTN:BTK,1:3)));
        ymax=max(max(UK(BTN:BTK,1:3)));
        subplot(212), axis([T(BTN,1) T(BTK,1) ymin ymax])
        plot(T(BTN:BTK,1),UK(BTN:BTK,1),':',....
            T(BTN:BTK,1),UK(BTN:BTK,2),'-',....
            T(BTN:BTK,1),UK(BTN:BTK,3),'-.')
        ylabel('U_{kraj}, [kV]'); xlabel('t, [s]');
        grid on;
    end
    
    %   
    if otg==2,
        fprintf('#       %6.4f  %6.4f s...\n\n', tnacn, tkrn);
        h = figure('NumberTitle', 'off', 'Name', '    ');
        
        ymin=min(min(IN(BTN:BTK,1:3))); ymax=max(max(IN(BTN:BTK,1:3)));
        subplot(211), axis([T(BTN,1) T(BTK,1) ymin ymax]);
        plot(T(BTN:BTK,1),IN(BTN:BTK,1),':r');
        ylabel('I, [A]'); xlabel('t, [s]');
        grid on; legend(' I_{A}');
        
        subplot(212), axis([T(BTN,1) T(BTK,1) ymin ymax])
        plot(T(BTN:BTK,1),IN(BTN:BTK,2),'-g',....
            T(BTN:BTK,1),IN(BTN:BTK,3),'-.b')
        ylabel('I, [A]'); xlabel('t, [s]');
        grid on; legend(' I_{B}', ' I_{C}');
    end
end

%% 
